/* draw boxes at each click and drag */
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Point;
import java.awt.event.*;

public class Problem4 extends java.applet.Applet
   implements MouseListener,MouseMotionListener {

    final int MAXBOXES = 10;
    Point starts[] = new Point[MAXBOXES]; // starting points
    Point ends[] = new Point[MAXBOXES];    // endingpoints
    Point anchor;    // start of current box
    Point currentpoint; // current end of box
    int currbox = 0; // number of boxes

    public void init() {
        setBackground(Color.white);
		// register event listeners
		addMouseListener(this);
		addMouseMotionListener(this);
    }

	// needed to satisfy listener interfaces
    public void mouseMoved(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}

	// same as mouseDown
    public void mousePressed(MouseEvent e) {
       if (currbox < MAXBOXES)
           anchor = new Point(e.getX(),e.getY());
       else 
        	System.out.println("Too many boxes.");
    }

	// same as mouseUp
    public void mouseReleased(MouseEvent e) {
        if (currbox < MAXBOXES) 
            addbox(e.getX(),e.getY());
    }

	// same as mouseDrag
	public void mouseDragged(MouseEvent e) {
       if (currbox < MAXBOXES) {
           currentpoint = new Point(e.getX(),e.getY());
           repaint();
        }
    }

    void addbox(int x,int y) {
        starts[currbox] = anchor;
        ends[currbox] = new Point(x,y);
        currbox++;
        currentpoint = null;
		anchor = null;
        repaint();
    }

    public void paint(Graphics g) {

		int height, width;							//New vars to simplify things
		int stx, sty;								//Starting coords

        // Draw existing boxes
        for (int i = 0; i < currbox; i++) {
			/* Original code here commented out
            g.drawLine(starts[i].x, starts[i].y, ends[i].x, ends[i].y); */
			
			if(ends[i].x > starts[i].x)			//See which point needs to be the starting one
				stx = starts[i].x;
			else
				stx = ends[i].x;
			
			if(ends[i].y > starts[i].y)
				sty = starts[i].y;
			else
				sty = ends[i].y;
			
			
			width = Math.abs(ends[i].x - starts[i].x);	//Calculate our width
			height = Math.abs(ends[i].y - starts[i].y); //Calculate our height
			g.drawRect(stx, sty, width, height);
        }

        // draw current box
        g.setColor(Color.blue);
        if (currentpoint != null){
			width = Math.abs(currentpoint.x - anchor.x);		//Calculate the width
			height = Math.abs(currentpoint.y - anchor.y);		//Calculate the height

			/* Original code here commented out 
            g.drawLine(anchor.x,anchor.y, currentpoint.x,currentpoint.y); */
			
			if(anchor.x > currentpoint.x)			//See which point needs to be the starting one
				stx = currentpoint.x;
			else
				stx = anchor.x;
			
			if(anchor.y > currentpoint.y)
				sty = currentpoint.y;
			else
				sty = anchor.y;
			
			g.drawRect(stx, sty, width, height);

		}//if
    }
}
