import java.lang.Thread;
import java.lang.InterruptedException;

/*
 *
 * SearchThread
 *
 */
class SearchThread extends Thread
{

	private int[] elements;				//Array of elements to examine
	private boolean isTarget;			//Boolean to determine if this is the one
	private int index;					//The index that this object looks at
	private int low, high;				//The array bounds for this guy
	private int searchval;				//The item to look for
	private SearchThread left, right;	//Left and right ones to spawn

	public SearchThread(int target){	//Constructor
		index = -1;
		isTarget = false;
		searchval = target;
		left = null;
		right = null;
	}//constructor

	public void setArray(int[] elem, int lowparam, int highparam){
		elements = elem;
		high = highparam;
		low = lowparam;
		index = (low+high)/2;
	}//setArray method

	public void run(){						//Here we go...
		System.out.print(index + "...");
		if(elements[index]==searchval){		//If we found the search value
			isTarget = true;				//We're the one!
		}									//Just drop through run
		else{
			if(high!=low){					//Don't go any farther, array width of 1
				StartMonitorChildren();		//Start up the children and wait for them
			}//if
		}//else (not the target)
	}//run method

	private void StartMonitorChildren(){
 		
		left = new SearchThread(searchval);		
		if(index!=low){							//If we need to still go left...
			left.setArray(elements, low, index-1);
			left.start();
		}

		right = new SearchThread(searchval);
		if(index!=high){
			right.setArray(elements, index+1, high);
			right.start();
		}
		
		index = -1;						//Set up for not found condition...
					
		try{
			left.join();				//Try waiting 100ms for left one to die
			if(!left.isAlive()){		//If the left one stopped
				if(left.isTarget()){	//If the left one was successful
					index = left.getIndex();
					isTarget = true;
				}//if (left one found it)
			}//if
			right.join();
			if(!right.isAlive()){
				if(right.isTarget()){			//If the right child was successful
					index = right.getIndex();
					isTarget = true;			//Condition needed to pass back down
				}//if(right one found it)
			}//if

		}//try
		catch(InterruptedException e){
			//DOH!
		}//catch

	}//StartMonitorChildren method

	public boolean isTarget(){
		return isTarget;
	}//isTarget method

	public int getIndex(){
		return index;
	}//getIndex method

}//SearchThread class

